/*
 *
 * Copyright notice
 *
 * (c) sgalinski Internet Services (https://www.sgalinski.de)
 *
 * All rights reserved
 *
 * This script is part of the TYPO3 project. The TYPO3 project is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 *
 * This script is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * This copyright notice MUST APPEAR in all copies of the script!
 */

define([
	'jquery',
	'TYPO3/CMS/Backend/ModuleMenu',
	'TYPO3/CMS/Backend/Viewport'
], function ($, ModuleMenu, Viewport) {
	var SgJobs = {
		init: function() {
			$('.sg-jobs_pageswitch').on('click', function(event) {
				event.preventDefault();
				SgJobs.goTo('web_SgJobsBackend', event.target.dataset.page, event.target.dataset.path);
			});
		},
		/**
		 * Switch the page and select it in the pagetree
		 *
		 * @param module
		 * @param id
		 * @param path
		 */
		goTo: function(module, id, path) {
			if (TYPO3.version < 9000000) {
				var tree = top.Ext.getCmp('typo3-pagetree');
				if (tree) {
					tree.activeTree.selectPath(path);
				} else if (top.nav) {
					top.nav.invokePageId(id, function(path) {
						var callback = top.Ext.createDelegate(top.nav.mainTree.selectPath, top.nav.mainTree);
						callback.apply(this, arguments);
						var node = top.nav.getSelected();
						if (node) {
							top.TYPO3.Components.PageTree.Actions.singleClick(node, top.TYPO3.Components.PageTree.Tree);
						}
					});
				}
				parent.TYPO3.ModuleMenu.App.showModule(module, 'id=' + id);
			} else {
				var pageTreeNodes = Viewport.NavigationContainer.PageTree.instance.nodes;
				for (var nodeIndex in pageTreeNodes) {
					if (pageTreeNodes.hasOwnProperty(nodeIndex) && pageTreeNodes[nodeIndex].identifier === parseInt(id)) {
						Viewport.NavigationContainer.PageTree.selectNode(pageTreeNodes[nodeIndex]);
						break;
					}
				}
				ModuleMenu.App.showModule(module, 'id=' + id);
			}
		}
	};
	TYPO3.SgJobs = SgJobs;

	SgJobs.init();

	return SgJobs;
});
